'use strict';

exports.__esModule = true;

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _resourceProcessorBase = require('./resource-processor-base');

var _resourceProcessorBase2 = _interopRequireDefault(_resourceProcessorBase);

var _lruCache = require('lru-cache');

var _lruCache2 = _interopRequireDefault(_lruCache);

var _script = require('../script');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ScriptResourceProcessor = function (_ResourceProcessorBas) {
    (0, _inherits3.default)(ScriptResourceProcessor, _ResourceProcessorBas);

    function ScriptResourceProcessor() {
        (0, _classCallCheck3.default)(this, ScriptResourceProcessor);

        var _this = (0, _possibleConstructorReturn3.default)(this, _ResourceProcessorBas.call(this));

        _this.jsCache = new _lruCache2.default({
            // NOTE: Max cache size is 50 MBytes.
            max: 50 * 1024 * 1024,

            length: function length(n) {
                // NOTE: 1 char ~ 1 byte.
                return n.length;
            }
        });
        return _this;
    }

    ScriptResourceProcessor.prototype.processResource = function processResource(script) {
        var processedScript = this.jsCache.get(script);

        if (!processedScript) {
            processedScript = (0, _script.processScript)(script, true);
            this.jsCache.set(script, processedScript);
        }

        return processedScript;
    };

    ScriptResourceProcessor.prototype.shouldProcessResource = function shouldProcessResource(ctx) {
        return ctx.contentInfo.isScript;
    };

    return ScriptResourceProcessor;
}(_resourceProcessorBase2.default);

exports.default = new ScriptResourceProcessor();
module.exports = exports['default'];